var MagnifyingGlassLayer = cc.Layer.extend({
    ctor: function () {
        this._super();

        var size = cc.winSize;

        var bg_hd = new cc.Sprite('res/game/popcorn/' + 'bg_hd' + '.png');
        this.addChild(bg_hd);
        bg_hd.setAnchorPoint(0, 0);

        var cnt = 4;
        for (var i = 0; i < cnt; ++i) {
            var fish = new cc.Sprite('res/game/fishing/' + 'fish' + i + '.png')
            fish.setPosition(size.width / cnt * (i + 1 / 2), cc.winSize.height / cnt * (i + 1 / 2));
            this.addChild(fish);
        }

        for (var i = 0; i < cnt; ++i) {
            var fish = new cc.Sprite('res/game/fishing/' + 'fish' + i + '_bite.png')
            fish.setPosition(size.width / cnt * (i + 1 / 2), cc.winSize.height - cc.winSize.height / cnt * (i + 1 / 2));
            this.addChild(fish);
        }

        // this.pRTex = new cc.RenderTexture(size.width, size.height);
        // this.pRTex.setPosition(size.width / 2, size.height / 2);
        // this.addChild(this.pRTex, 10);
        //
        // this.pRTex.begin();
        // this.visit();
        // this.pRTex.end();
        // this.pRTex.setVisible(false);
        //
        // var spr = new cc.Sprite(this.pRTex.getSprite().getSpriteFrame());
        // // this.addChild(spr, 100);
        // spr.setPosition(size.width / 2, size.height / 2);
        // spr.setRotationX(180);
        // var maskNode = cc.ClippingNode();
        // this.addChild(maskNode, 100);
        // var stencil = new cc.DrawNode();
        // stencil.drawDot(cc.p(0, 0), 100, cc.color(255, 0, 0, 255));
        // maskNode.setStencil(stencil);
        // maskNode.setInverted(false);
        // maskNode.setAlphaThreshold(0.5);
        // maskNode.addChild(spr);
        //
        // stencil.setPosition(size.width / 2, size.height / 2);
        // spr.setAnchorPoint(0.5, 0.5);       // 放大镜显示出来的
        // spr.setScale(1.5);
        //
        // this.lookAt = function (pos) {
        //     zLog('look at');
        //     stencil.setPosition(pos);
        //     spr.setPosition(pos);
        //     spr.setAnchorPoint(pos.x / size.width, 1 - pos.y / size.height);
        //     spr.setScale(1.5);
        // };
        //
        // // this.lookAt(cc.p(size.width / 2, size.height / 2));
        // // this.lookAt(cc.p(0, 0));
        // this.lookAt(cc.p(400, 200));

        // this.pRTex.setRotationX(180);
        // this.pRTex.setVirtualViewport(
        //     cc.p(50, 50),
        //     cc.rect(200, 200, 200, 200),
        //     cc.rect(200, 200, 200, 200)
        // );

        // var drawNode = new cc.DrawNode();
        // this.addChild(drawNode);
        // for (var i = 0; i < size.width / 100; ++i) {
        //     drawNode.drawSegment(cc.p(100 * (i + 1), 0), cc.p(100 * (i + 1), size.height), 2, cc.color(255, 0, 0, 255));
        // }
        // for (var i = 0; i < size.height / 100; ++i) {
        //     drawNode.drawSegment(cc.p(0, 100 * (i + 1)), cc.p(size.width, 100 * (i + 1)), 2, cc.color(0, 0, 255, 255));
        // }

        // cc.eventManager.addListener({
        //     event: cc.EventListener.TOUCH_ONE_BY_ONE,
        //     onTouchBegan: function (touches, event) {
        //         cc.log("start");
        //         var target = event.getCurrentTarget();
        //         return true;
        //     },
        //     onTouchMoved: function (touch, event) {
        //         var target = event.getCurrentTarget();
        //         target.pEraser.setPosition(touch.getLocation());
        //         target.eraseByBlend();
        //     }
        // }, this);
        // this.eraseByBlend = function () {
        //     this.pEraser.setBlendFunc(cc.GL_ONE_MINUS_SRC_ALPHA, cc.ZERO);
        //     this.pRTex.begin();
        //     this.pEraser.visit();
        //     this.pRTex.end();
        // };
    }
});

var MagnifyingGlassScene = cc.Scene.extend({
    ctor: function () {
        this._super();
        var size = cc.winSize;
        var wid = size.width;
        var hei = size.height;
        var layer = new MagnifyingGlassLayer();
        this.addChild(layer);

        // 截图时的起点始终为(0,0)
        var cutWid = wid / 3;  // 截取的宽
        var cutHei = hei / 2;  // 截取的高
        var pRTex = new cc.RenderTexture(cutWid, cutHei);

        this.addChild(pRTex);
        // zLog('size pRTex : ', pRTex.getContentSize().width.toFixed(0), ',', pRTex.getContentSize().height.toFixed(0));
        // zLog('size pRTex.getSprite() : ', pRTex.getSprite().getContentSize().width.toFixed(0), ',', pRTex.getSprite().getContentSize().height.toFixed(0));
        // pRTex.getSprite().setPosition(size.width / 2, size.height / 2);
        pRTex.setPosition(size.width / 2, size.height / 2);

        var oX = -600;
        var oY = -400;

        var a1 = -400;   // 影响矩形中心 x 坐标
        var b1 = -400;   // 影响矩形中心 y 坐标
        var c1 = 1;
        var d1 = 1;

        var a2 = 0;
        var b2 = 600;
        var c2 = 1;   // 展示矩形 宽系数
        var d2 = 1;   // 展示矩形 高系数


        var origin = cc.p(oX, oY);
        var fullRect = cc.rect(oY + a1, oY + b1, wid * c1, wid * d1);
        var virtualViewPort = cc.rect(oX + a2, hei + b2, wid * c2, hei * d2);
        pRTex.setVirtualViewport(origin, fullRect, virtualViewPort);

        var centerX = cutWid + a1 * c2;      // 矩形左下角 x 坐标 在截全屏时
        var CutXR = cutWid / 2 + cutWid * c2;

        pRTex.begin();
        layer.visit();
        pRTex.end();

        var drawNode = new cc.DrawNode();
        this.addChild(drawNode);
        for (var i = 0; i < size.width / 100; ++i) {
            drawNode.drawSegment(cc.p(100 * (i + 1), 0), cc.p(100 * (i + 1), size.height), 1, cc.color(255, 0, 0, 255));
        }
        for (var i = 0; i < size.height / 100; ++i) {
            drawNode.drawSegment(cc.p(0, 100 * (i + 1)), cc.p(size.width, 100 * (i + 1)), 1, cc.color(0, 0, 255, 255));
        }
        // var vs = pRTex.getSprite().getContentSize();
        // drawNode.drawRect(pRTex.getPosition(), cc.pAdd(pRTex.getPosition(), cc.p(vs.width, vs.height)), cc.color(255, 0, 0, 255), 1, cc.color(0, 0, 255, 255));
    }
});