let dir = 'res/game/coin_dozer/';
var Global_DP_CoinDozer = {
    // dir: 'res/game/coin_dozer/',
    layer: null,
    coinManager: null,
    coin_box: null,
    timeClock: null,
    tip_hand: null
};

function DP_CoinDozer_CoinManager() {
    this.gameOver = false;
    this.score = 0;
    this.coinIdx = 0;
}

let yUp = 410;
let yDn = 360;
let scaleUp = 0.93;
let scaleDn = 0.99;
let timeUp2Dn = 2;
let coinMess = 1;

var DP_CoinDozerLayer = cc.Layer.extend({
    timeRemain: 0,
    stepTime: 1 / 60.0,
    ctor: function () {
        this._super();
        this.x = cc.winSize.width / 2;
        this.y = Global_DP.sinkY;
        Global_DP_CoinDozer.layer = this;

        this.addRes();
        this.addMachine();
        this.loadPhysicsSpace();
        // this.loadPhysicsSpaceDebug();
        this.addMachineBoard();
        this.addCoinBox();
        this.addTimeClock();
        this.addCoinManager();
        this.addTipHand();

        zAddBackButtonBegin(this);

        this.scheduleUpdate();
    },
    onEnter: function () {
        this._super();
        // zPauseTargetEvent(this, true);
        this.pauseEventNode();
        this.countDown = function () {
            this.count_down.count();
            // zResumeTargetEvent(this, true);
            var coin_box = Global_DP_CoinDozer.coin_box;
            coin_box.setCoinNumber(zGetLocalCoinNumber());
        };
        zAddInsertCoinsLayer(this, this.addTeachLayer);
        this.startUpAndDn();
    },
    addTeachLayer: function () {
        var self = this;
        // var dir = Global_DP_CoinDozer.dir;
        var highlighted = zNewSpriteCreate(dir, 'highlighted', this);
        var eventArea = zNewSpriteCreate(dir, 'highlighted_eventArea', highlighted);
        var tip_hand = Global_DP_CoinDozer.tip_hand;
        var coin_box = Global_DP_CoinDozer.coin_box;
        // for (var i = 0; i < 3; ++i) {
        //     var arrow = zNewSpriteCreate(dir, 'arrow', eventArea);
        //     arrow.setAnchorPoint(0.5, 0);
        //     var dx = (i - (3 - 1) / 2) / 4;
        //     arrow.setPosition(eventArea.width * (47 / 100 + dx), eventArea.height);
        //     // zAddTouchLogPosEvent(arrow);
        // }
        var listener = zNewEventListenerCreate((touch, target) => {
            zPauseTargetEvent(target, true);
            var posInNode = target.convertToNodeSpace(touch.getLocation());
            var dx = Math.random() * 20;
            var pos = null;
            if (posInNode.x < target.width / 3) {
                pos = cp.v(-200 + dx, 650);
            } else if (posInNode.x > target.width * 2 / 3) {
                pos = cp.v(200 + dx, 650);
            } else {
                pos = cp.v(dx, 650);
            }
            var coinSprite = self.addCoinOrToy(pos, 'coin');
            ddSound.playEffect('game_coin_dozer_coin_drop');
            coinSprite.runAction(cc.sequence(
                cc.moveBy(0.5, 0, -200).easing(cc.easeIn(3)),
                cc.callFunc(function () {
                    zSetSpriteTexture(dir, 'coin0', coinSprite);
                    coinSprite.setLocalZOrder(10);
                    self.coins.push(coinSprite.getBody());
                    if (self.board.direction == 'toUp') {
                        coinSprite.runAction(cc.moveBy(timeUp2Dn, 0, yUp - self.board.sprite.y));
                    } else if (self.board.direction == 'toDn') {
                        coinSprite.runAction(cc.moveBy(timeUp2Dn, 0, yDn - self.board.sprite.y));
                    }
                    self.countDown();
                })
            ));
            highlighted.removeFromParent(true);
            tip_hand.removeFromParent(true);
        }, null, null, null);
        highlighted.setLocalZOrder(50);
        highlighted.setAnchorPoint(0.5, 0);
        eventArea.setPosition(836.39, 572.72);
        eventArea.setOpacity(0);
        zSetNodeEvent(listener, eventArea);
        // zAddTouchLogPosEvent(eventArea);

        coin_box.setCoinNumber(zGetLocalCoinNumber());
        tip_hand.autoTipAction(cc.p((Math.floor(Math.random() * 3 - 1) + 0.3) * eventArea.width / 4, eventArea.y - 30));

        ddSound.stopAll();
        ddSound.playEffect('game_coin_dozer_click_this_many_coin_show');
    },
    update: function (dt) {
        this.timeRemain += dt;
        while (this.timeRemain - this.stepTime >= 0) {
            this.space.step(this.stepTime);
            this.timeRemain -= this.stepTime;
        }
        // 处理硬币
        for (var i = 0; i < this.coins2.length; ++i) {
            var coin = this.coins2[i];
            if (coin.sprite.y < 255) {
                this.coins2.splice(i, 1);
                i--;
                // delCoin.push(coin);
                (function f(coin, self) {
                    zSetSpriteTexture(dir, 'coin1', coin.sprite);
                    coin.sprite.runAction(cc.sequence(
                        cc.moveBy(0.5, 0, -400).easing(cc.easeIn(3)),
                        cc.callFunc(function () {
                            if (!Global_DP_CoinDozer.coinManager.gameOver) {
                                var coin_box = Global_DP_CoinDozer.coin_box;
                                var p1 = cc.pAdd(zGetNodePosition(coin_box, zGetWorldPosition(coin.sprite)), cc.p(0, 50));
                                coin_box.runGetCoinAction(p1, 1);
                                // coin_box.addScore(1);
                            }
                            var shape = coin.shape;
                            self.space.removeShape(shape);
                            self.space.removeBody(coin);
                        }.bind(self)),
                        cc.removeSelf(true)
                    ));
                })(coin, this)
            }
        }
        // 处理玩具
        for (var i = 0; i < this.toys.length; i++) {
            var toy = this.toys[i];
            if (toy.sprite.y < 255) {
                this.toys.splice(i, 1);
                i--;
                (function f(toy, self) {
                    toy.sprite.runAction(cc.sequence(
                        cc.moveBy(0.5, 0, -400).easing(cc.easeIn(3)),
                        cc.callFunc(function () {
                            if (toy.idt == 'toy9') {        // 闹钟玩具
                                var timeClock = Global_DP_CoinDozer.timeClock;
                                if (!Global_DP_CoinDozer.coinManager.gameOver) {
                                    timeClock.rewardTime(5);
                                }
                                // timeClock.setCurTime(timeClock.getCurTime() + 5);
                            } else if (!Global_DP_CoinDozer.coinManager.gameOver) {
                                var coin_box = Global_DP_CoinDozer.coin_box;
                                var p1 = cc.pAdd(zGetNodePosition(coin_box, zGetWorldPosition(toy.sprite)), cc.p(0, 0));
                                // coin_box.runGetCoinAction(p1, 4);
                                coin_box.runGetCoinAction2(p1, 3);
                                // coin_box.addScore(5);
                            }
                            var shape = toy.shape;
                            self.space.removeShape(shape);
                            self.space.removeBody(toy);

                        }),
                        cc.removeSelf(true)
                    ))
                })(toy, this)
            }
        }
    },
    addRes: function () {
        var arrName = ['bg_hd', 'desk', 'hole'];
        var res = zAddRes(dir, arrName, this);
        var bg_hd = res[0];
        var desk = res[1];
        var hole = res[2];
        bg_hd.setAnchorPoint(0.5, 0);
        desk.setPosition(7.70, 264.75);
        hole.setPosition(-5.76, 125.94);
    },
    addMachine: function () {
        // var dir = Global_DP_CoinDozer.dir;
        var machine = zNewSpriteCreate(dir, 'machine', this);
        var machine1 = zNewSpriteCreate(dir, 'machine1', this);
        var machine2 = zNewSpriteCreate(dir, 'machine2', machine);
        var machine3 = zNewSpriteCreate(dir, 'machine3', this);

        machine.setPosition(-0.50, 742.38);
        machine1.setPosition(this.convertToNodeSpace(machine.convertToWorldSpace(cc.p(405.54, 165.44))));
        machine1.setLocalZOrder(1);
        machine2.setPosition(403.04, -116.20);
        machine3.setPosition(this.convertToNodeSpace(machine.convertToWorldSpace(cc.p(401.89, 21.70))));
        machine3.setLocalZOrder(3);
        // zAddTouchLogPosEvent(machine);
        // zAddTouchLogPosEvent(machine1);
        // zAddTouchLogPosEvent(machine2);
        // zAddTouchLogPosEvent(machine3);
    },
    loadPhysicsSpace: function () {
        this.space = new cp.Space();
        this.space.gravity = cp.v(0, 0);
        this.space.sleepTimeThreshold = 0.5;
        this.space.damping = 0.2;
    },
    loadPhysicsSpaceDebug: function () {
        var node = new cc.PhysicsDebugNode(this.space);
        this.addChild(node, Number.MAX_VALUE);
    },
    addCoinManager: function () {
        var coinManager = new DP_CoinDozer_CoinManager();
        Global_DP_CoinDozer.coinManager = coinManager;
    },
    addMachineBoard: function () {
        var self = this;
        var space = this.space;
        // var dir = Global_DP_CoinDozer.dir;
        // 推板正面
        var mess = 1000000;
        var boardSprite = new cc.PhysicsSprite(zGetFullPathPNG(dir, 'machine_board_side'));
        var boardBody = new cp.Body(mess, cp.momentForBox(mess, boardSprite.width, boardSprite.height));
        var boardShape = new cp.BoxShape(boardBody, boardSprite.width * 0.9, 1);
        boardBody.setPos(cp.v(0, yUp));
        boardBody.idt = 'board';
        boardBody.collisionType = 212;
        boardBody.sprite = boardSprite;
        boardShape.setCollisionType(boardBody.collisionType);
        boardSprite.setBody(boardBody);
        boardSprite.setVisible(true);
        boardSprite.setScale(scaleUp, 1);
        boardSprite.setAnchorPoint(0.5, 0.25);
        space.addBody(boardBody);
        space.addShape(boardShape);
        // 推板的遮罩
        var mask = new cc.ClippingNode();
        var stencil = new cc.Sprite(zGetFullPathPNG(dir, 'machine_board_above'));
        stencil.setPosition(0, 600);
        mask.setStencil(stencil);
        mask.setAlphaThreshold(0.5);
        mask.setInverted(true);
        mask.addChild(boardSprite);
        this.addChild(mask);
        this.board = boardBody;
        // 推板上面
        var mba = zNewSpriteCreate(dir, 'machine_board_above', boardSprite);
        mba.setAnchorPoint(0.5, 0);
        mba.setPosition(boardSprite.width / 2, boardSprite.height);
        boardBody.direction = null;
        // this.schedule(this.boardDn, timeUp2Dn * 2, cc.REPEAT_FOREVER, 0.001);
        // this.schedule(this.boardUp, timeUp2Dn * 2, cc.REPEAT_FOREVER, timeUp2Dn);

        // 硬币
        var coins = [];
        var coins2 = [];
        var toys = [];
        for (var i = 0; i < 5; ++i) {
            var coinSprite = this.addCoinOrToy(cp.v((i - 2) * 150, 310), 'coin0');
            coins2.push(coinSprite.getBody());
        }

        this.coins = coins;
        this.coins2 = coins2;
        this.toys = toys;

        var wallBody = new cp.StaticBody();
        var wallShape = new cp.SegmentShape(wallBody, cp.v(-321.82, 508.03), cp.v(321.82, 508.03), 2);
        wallBody.idt = 'wall';
        var wallShapeL = new cp.SegmentShape(new cp.StaticBody(), cp.v(-323.88, 496.17), cp.v(-466.47, 247.72), 2);
        var wallShapeR = new cp.SegmentShape(new cp.StaticBody(), cp.v(323.88, 496.17), cp.v(466.47, 247.72), 2);
        space.addShape(wallShape);
        space.addShape(wallShapeL);
        space.addShape(wallShapeR);

        this.space.addCollisionHandler(boardBody.collisionType, coinSprite.getBody().collisionType,
            this.collisionBegin.bind(this),
            this.collisionBegin.bind(this),
            this.collisionPost.bind(this),
            this.collisionSeparate.bind(this)
        );

        var eventNode = new cc.Node();
        eventNode.setContentSize(cc.winSize.width, cc.winSize.height - Global_DP.sinkY);
        eventNode.setPosition(-cc.winSize.width / 2, 0);
        eventNode.time = new Date();
        var listener = zNewEventListenerCreate(function (touch, target) {
            if ((new Date().getTime() - target.time.getTime()) < 500) {
                // zLog('time is too short');
                return;
            }
            target.time = new Date();
            var pos = self.convertToNodeSpace(cc.p(touch.getLocation()));
            // zLog('y : ', pos.y);
            var N = 10;
            var random = Math.floor(Math.random() * N);
            var dx = Math.random() * 20;
            var cpv = null;
            if (pos.x < -128 && pos.x > -385) {
                cpv = cp.v(-200 + dx, 650);
            } else if (pos.x > 128 && pos.x < 385) {
                cpv = cp.v(200 + dx, 650);
            } else if (pos.x <= 128 && pos.x >= -128) {
                cpv = cp.v(dx, 650);
            } else {
                return;
            }
            // 玩具出现
            if (random > N - 3) {
                var toySprite = self.addCoinOrToy(cpv, 'toy');
                toySprite.runAction(cc.sequence(
                    cc.moveBy(0.5, 0, -350).easing(cc.easeIn(3)),
                    cc.callFunc(function () {
                        toySprite.setLocalZOrder(20);
                        ddSound.playEffect('game_all_fly');
                        self.toys.push(toySprite.getBody());
                    })
                ));

                return;
            }
            // 硬币出现
            var coinSprite = self.addCoinOrToy(cpv, 'coin');
            coinSprite.runAction(cc.sequence(
                cc.moveBy(0.5, 0, -200).easing(cc.easeIn(3)),
                cc.callFunc(function () {
                    zSetSpriteTexture(dir, 'coin0', coinSprite);
                    coinSprite.setLocalZOrder(10);
                    self.coins.push(coinSprite.getBody());
                    ddSound.playEffect('game_coin_dozer_coin_drop');
                    if (self.board.direction == 'toUp') {
                        coinSprite.runAction(cc.moveBy(timeUp2Dn, 0, yUp - self.board.sprite.y));
                    } else if (self.board.direction == 'toDn') {
                        coinSprite.runAction(cc.moveBy(timeUp2Dn, 0, yDn - self.board.sprite.y));
                    }
                })
            ));
        }, null, null, null);
        zSetNodeEvent(listener, eventNode);
        this.addChild(eventNode);
        this.eventNode = eventNode;
    },
    pauseEventNode: function () {
        zPauseTargetEvent(this.eventNode, true);
    },
    resumeEventNode: function () {
        zResumeTargetEvent(this.eventNode, true);
    },
    addCoinOrToy: function (pos, type) {
        var space = this.space;
        if (type == 'coin' || type == 'coin0') {
            var sprite = new cc.PhysicsSprite(zGetFullPathPNG(dir, type == 'coin' ? 'coin1' : type));
            // var coinBody = new cp.Body(coinMess, cp.momentForBox(coinMess, coinSprite.width, coinSprite.height));
            // var coinShape = new cp.BoxShape(coinBody, coinSprite.width * 0.9, coinSprite.height * 0.6);
            var body = new cp.Body(coinMess, cp.momentForCircle(coinMess, sprite.width * 0.5, 0, cp.v(0, 0)));
            var shape = new cp.CircleShape(body, sprite.width * 0.3, cp.v(0, 0));
        } else if (type == 'toy') {
            var name = Math.floor(Math.random() * 10);
            var sprite = new cc.PhysicsSprite(zGetFullPathPNG(dir, 'toy' + name));
            if (name == 8 || name == 9) {
                var body = new cp.Body(coinMess, cp.momentForCircle(coinMess, sprite.width * 0.5, 0, cp.v(0, 0)));
                var shape = new cp.CircleShape(body, sprite.width * 0.5, cp.v(0, 0));
            } else {
                var body = new cp.Body(coinMess, cp.momentForBox(coinMess, sprite.width, sprite.height));
                // 形状大小
                if (name == 7) {
                    var shape = new cp.BoxShape(body, sprite.width * 0.9, sprite.height * 0.9);
                } else {
                    var shape = new cp.BoxShape(body, sprite.width * 0.9, sprite.height * 0.6);
                }
                // 设置锚点
                if (name == 1 || name == 2) {
                    sprite.setAnchorPoint(0.5, 0.3);
                } else if (name == 3 || name == 4) {
                    sprite.setAnchorPoint(0.5, 0.5);
                } else if (name == 6) {
                    sprite.setAnchorPoint(0.5, 0.3);
                } else if (name == 0 || name == 7) {
                    sprite.setAnchorPoint(0.5, 0.35);
                } else {
                    sprite.setAnchorPoint(0.5, 0.2);
                }
            }
        }

        body.setPos(cp.v(pos.x, pos.y));
        body.sprite = sprite;
        body.collisionType = ('coin' ? 121 : 131);
        body.shape = shape;
        body.idt = (type == 'coin' ? 'coin' : 'toy' + name);
        shape.setFriction(50);
        shape.setCollisionType(body.collisionType);
        sprite.setBody(body);

        space.addBody(body);
        space.addShape(shape);
        this.addChild(sprite, (type == 'coin' ? 0 : 10));

        return sprite;
    },
    collisionBegin: function (arbiter, space) {
        var shapes = arbiter.getShapes();
        var shapeA = shapes[0];
        var shapeB = shapes[1];
        var bodyA = shapeA.getBody();
        var bodyB = shapeB.getBody();
        if (bodyA.idt == 'board' && bodyB.idt == 'coin') {
            zSetSpriteTexture(dir, 'coin1', bodyB.sprite);
            bodyB.sprite.stopAllActions();
            bodyB.sprite.runAction(cc.sequence(
                cc.moveBy(0.5, 0, -150).easing(cc.easeIn(3)),
                cc.callFunc(function () {
                    zSetSpriteTexture(dir, 'coin0', bodyB.sprite);
                })
            ));
            bodyB.idt = null;
            var idx = this.coins.indexOf(bodyB);
            if (idx >= 0) {
                this.coins.splice(idx, 1);
            }
            this.coins2.push(bodyB);
        }
        return true;
    },
    collisionPre: function (arbiter, space) {
        return true;
    },
    collisionPost: function (arbiter, space) {
        return true;
    },
    collisionSeparate: function (arbiter, space) {
        return true;
    },
    boardUp: function () {    // 拉
        this.board.direction = 'toUp';
        this.board.sprite.stopAllActions();
        this.board.sprite.runAction(cc.spawn(
            cc.moveTo(timeUp2Dn, 0, yUp), cc.scaleTo(timeUp2Dn - 0.5, scaleUp, 1)
        ));

        for (var i = 0; i < this.coins.length; ++i) {
            // this.coins[i].sprite.stopAllActions();
            this.coins[i].sprite.runAction(cc.moveBy(timeUp2Dn, 0, yUp - this.board.sprite.y))
            // this.coins[i].sprite.runAction(cc.moveBy(timeUp2Dn * (yUp - this.board.sprite.y) / (yUp - yDn), 0, yUp - this.board.sprite.y))
        }
    },
    boardDn: function () {    // 推
        ddSound.playEffect('game_coin_dozer_push_coin');
        this.board.direction = 'toDn';
        this.board.sprite.stopAllActions();
        this.board.sprite.runAction(cc.spawn(
            cc.moveTo(timeUp2Dn, 0, yDn), cc.scaleTo(timeUp2Dn, scaleDn, 1)
        ));

        for (var i = 0; i < this.coins.length; ++i) {
            // this.coins[i].sprite.stopAllActions();
            this.coins[i].sprite.runAction(cc.moveBy(timeUp2Dn, 0, yDn - this.board.sprite.y))
            // this.coins[i].sprite.runAction(cc.moveBy(timeUp2Dn * (yDn - this.board.sprite.y) / (yUp - yDn), 0, yDn - this.board.sprite.y))
        }
    },
    startUpAndDn: function () {
        this.schedule(this.boardDn, timeUp2Dn * 2, cc.REPEAT_FOREVER, 0.001);
        this.schedule(this.boardUp, timeUp2Dn * 2, cc.REPEAT_FOREVER, timeUp2Dn);
    },
    addCoinBox: function () {
        var coin_box = zAddCoinBox(this);
        coin_box.addScore = function (score) {
            var coinManager = Global_DP_CoinDozer.coinManager;
            if (coinManager.gameOver) {
                return;
            }
            coin_box.setCoinNumber(coin_box.getCoinNumber() + score);
            coinManager.score += score;
        };
        Global_DP_CoinDozer.coin_box = coin_box;
    },
    addTimeClock: function () {
        var timeTotal = 30;
        var self = this;
        var time_out_cb = function () {
            // zLog('time out');
            var coinManager = Global_DP_CoinDozer.coinManager;
            coinManager.gameOver = true;
            // zPauseTargetEvent(self, true);
            self.pauseEventNode();
            // zLog('score : ', coinManager.score);
            zAddAwardCoinLayer(self, coinManager.score);
            umengEvent('GAME_SRC_DONE', 'coin_dozer');
        };
        var timeClock = zAddMyTimeClock(this, timeTotal, time_out_cb);
        timeClock.setLocalZOrder(50);
        Global_DP_CoinDozer.timeClock = timeClock;

        var count_down_0_cb = function () {
            self.resumeEventNode();
            // zResumeTargetEvent(self, true);
            timeClock.startTiming();
            // var coinManager = Global_DP_Shooting.coinManager;
            // self.startUpAndDn();
        };
        this.count_down = zAddCountDown(this, 1, 3, count_down_0_cb);
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_CoinDozer.tip_hand = tip_hand;
    }
});

var DP_CoinDozerScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_CoinDozerLayer();
        this.addChild(layer);

        zAddKeyboardBackEventCreate(this);
    }
});