var DP_DiningRoom_EatFood = cc.Node.extend({
    ctor: function () {
        this._super();
    },
    isHotDog: function (type) {
        var hot_dog = zNewSpriteCreate(Global_DP_DiningRoom_MakeHotDog.dir, 'eat_' + type, this);
        hot_dog.setPosition(hot_dog.width / 2, hot_dog.height / 2);
        this.setContentSize(hot_dog.getContentSize());
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.4);
    },
    isHamburg: function (types) {
        var ox = 220, oy = 200, dy = 50;
        var dir_hamburg = Global_DP_DiningRoom_MakeHamburg.dir;
        var hamburg_top = zNewSpriteCreate(dir_hamburg, 'hamburg_top', this);
        var hamburg_bottom = zNewSpriteCreate(dir_hamburg, 'hamburg_bottom', this);
        hamburg_top.setLocalZOrder(4);
        hamburg_top.setPosition(-0.46 + ox, 235.65 * 0.7 + oy - dy);
        hamburg_bottom.setPosition(5.40 + ox, -131.69 * 0.7 + oy - dy);
        for (var i = 0; i < 3; ++i) {
            var hamburg_food = zNewSpriteCreate(dir_hamburg, 'hamburg_' + types[i] + '_' + i, this);
            hamburg_food.setPosition(12.01 + ox, ((1 - i) * 70 + 40) * 0.7 + oy - dy);
            hamburg_food.setLocalZOrder(3 - i);
        }
        this.setContentSize(cc.size(ox * 2, oy * 2));
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.4);
        // zShowContentSize(this, this.getContentSize());
    },
    isCake: function (types) {
        var dir_cake = Global_DP_DiningRoom_MakeCake.dir;
        var cake_base = zNewSpriteCreate(dir_cake, 'cake_base_' + types[0], this);
        var cake_fruit = zNewSpriteCreate(dir_cake, 'cake_fruit_' + types[1], cake_base);
        cake_base.setPosition(cake_base.width / 2, cake_base.height / 2);
        cake_fruit.setPosition(297.03, 364.63);
        this.setContentSize(cake_base.getContentSize());
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.35);
    }
});
var DP_DiningRoom_EatDrink = cc.Node.extend({
    ctor: function () {
        this._super();

    },
    isCola: function (straw_type) {
        var dir_cola = Global_DP_DiningRoom_MakeCola.dir;
        var cup_behind = zNewSpriteCreate(dir_cola, 'cup_behind', this);
        var cup_cola = zNewSpineAnimationCreate(Global_DP_DiningRoom.dir + 'spine/', 'skeleton', this);
        var cup_front = zNewSpriteCreate(dir_cola, 'cup_front', this);
        cup_front.setPosition(cup_front.width / 2, cup_front.height / 2);
        cup_behind.setPosition(165.00, 399.04);
        cup_cola.setScale(1.8);
        cup_cola.setPosition(165.00, 199.04);
        var clr = ['fen', 'lv', 'huang'];
        cup_cola.setAnimation(0, 'kele' + clr[straw_type], false);

        this.setContentSize(cup_front.getContentSize());
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.5);
        this.juice = cup_cola;
        this.aniName = 'hekele' + clr[straw_type];
        // zShowContentSize(this, this.getContentSize());
    },
    isLemonJuice: function (straw_type) {
        var dir_lemon = Global_DP_DiningRoom_MakeLemonJuice.dir;
        var cup_behind = zNewSpriteCreate(dir_lemon, 'cup_behind', this);
        var cup_lemon = zNewSpineAnimationCreate(Global_DP_DiningRoom.dir + 'spine/', 'skeleton', this);
        var cup_front = zNewSpriteCreate(dir_lemon, 'cup_front', this);
        cup_front.setPosition(cup_front.width / 2, cup_front.height / 2);
        cup_behind.setPosition(140.96, 399.77);
        cup_lemon.setScale(1.85);
        cup_lemon.setPosition(142.00, 255.04);
        var clr = ['fen', 'lv', 'huang'];
        cup_lemon.setAnimation(0, 'ningmeng' + clr[straw_type], false);

        this.setContentSize(cc.size(cup_front.width, cup_front.height));
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.5);
        this.juice = cup_lemon;
        this.aniName = 'heningmeng' + clr[straw_type]
    },
    isIceCream: function (type) {
        var dir_ice_cream = Global_DP_DiningRoom_MakeIceCream.dir;
        var base = zNewSpriteCreate(dir_ice_cream, 'base_' + type[0], this);
        var head = zNewSpriteCreate(dir_ice_cream, 'head_' + type[1], base);
        var stick = zNewSpriteCreate(dir_ice_cream, 'stick_' + type[2], base);
        head.setPosition(179.34, 341.82);
        stick.setPosition(301.50, 451.39);
        stick.setLocalZOrder(-1);

        this.setContentSize(cc.size(base.width, base.height));
        this.setAnchorPoint(0.5, 0.5);
        this.setScale(0.4);
    }
});

var DP_DiningRoom_EatLayer = cc.Layer.extend({
    ctor: function (foodName, drinkName, eat_done_callBack) {
        this._super();
        // this.setPosition(0, 0);

        var self = this;
        var dir = Global_DP_DiningRoom.dir;
        var dir_eat = Global_DP_DiningRoom_ChooseInterface.dir;
        var eat = {food: false, drink: false, happy: false};

        var bg_hd = zNewSpriteCreate(dir_eat, 'bg_hd', this);
        bg_hd.setAnchorPoint(0.5, 0);

        var tip_hand = zAddTipHand(this);

        var role = zNewSpineAnimationCreate(dir + 'spine/', 'skeleton', this);
        var loop_count_chi = 0;
        role.setPosition(0, 378.62);
        role.setAnimation(0, 'huxi', true);
        role.eat = function (name) {
            role.eat_name = name;
        };
        role.setCompleteListener((trackEntry) => {
            var name = trackEntry.animation ? trackEntry.animation.name : '';
            if (name == 'chi') {
                loop_count_chi++;
                if (loop_count_chi >= 4) {
                    loop_count_chi = 0;
                    ddSound.stopEffect(role.eat2_effectId);
                    role.setAnimation(0, 'huxi', true);
                    // 吃冰淇淋
                    if (role.eat_name == 'ice_cream') {
                        role.eat_name = null;
                        eat.drink = true;
                        if (!eat.food) {
                            zResumeTargetEvent(tray.food, true);
                            // zLog('drink over !');
                        }
                    }
                    // 吃食物
                    else {
                        eat.food = true;
                        if (!eat.drink) {
                            zResumeTargetEvent(tray.drink, true);
                        }
                    }
                }
            } else if (name == 'he') {
                role.setAnimation(0, 'huxi', true);
                role.setTimeScale(1);
                ddSound.stopEffect(role.eat_drink_effectId);
                tray.drink.runAction(zGetBezierTo(0.3, tray.drink.getPosition(), tray.drink.pos_back).easing(cc.easeOut(2)));
                eat.drink = true;
                if (!eat.food) {
                    zResumeTargetEvent(tray.food, true);
                }
            } else if (name == 'kaixin') {
                // zLog('dining_room over !!!');
                eat_done_callBack();
            }
            if (eat.food && eat.drink && !eat.happy) {
                eat.happy = true;
                role.setAnimation(0, 'kaixin', false);
                // role.clearTrack();
            }
        });
        // role.setContentSize(cc.size(300, 300));
        // zShowContentSize(role);
        // zAddTouchLogPosEvent(role);

        var table = zNewSpriteCreate(dir, 'table', this);
        table.setPosition(role.x, role.y - 230);
        // table.setVisible(false);

        var tray = zNewSpriteCreate(dir, 'tray', this);
        tray.setPosition(table.x, table.y);
        tray.setVisible(false);
        tray.end_pos = cc.p(table.x, table.y);

        var listener = zNewEventListenerCreate(function (touch, target) {
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // 如果是食物
            // zPauseTargetEvent(target, true);
            zPauseTargetEvent(tray, true);
            if (target.isFood) {
                var role_world_pos = zGetWorldPosition(role);
                var tray_node_pos = tray.convertToNodeSpace(cc.pAdd(role_world_pos, cc.p(0, 50)));
                ddSound.playEffect('game_all_fly');
                target.runAction(cc.sequence(
                    // cc.moveTo(0.5, tray_node_pos)
                    cc.spawn(zGetBezierTo(0.5, target.getPosition(), tray_node_pos), cc.scaleBy(0.5, 0.5)).easing(cc.easeOut(2)),
                    cc.callFunc(() => {
                        target.setScale(0);
                        role.setAnimation(0, 'chi', true);
                        role.eat2_effectId = ddSound.playEffect('eat2', true);
                    })
                ));
            }
            // 否则是饮品
            else {
                // 吃冰淇淋
                if (target.getName().indexOf('ice_cream') >= 0) {
                    var role_world_pos = zGetWorldPosition(role);
                    var tray_node_pos = tray.convertToNodeSpace(cc.pAdd(role_world_pos, cc.p(50, 50)));
                    ddSound.playEffect('game_all_fly');
                    target.runAction(cc.sequence(
                        cc.spawn(zGetBezierTo(0.5, target.getPosition(), tray_node_pos), cc.scaleBy(0.5, 0.5)).easing(cc.easeOut(2)),
                        cc.callFunc(() => {
                            target.setScale(0);
                            role.setAnimation(0, 'chi', true);
                            role.eat2_effectId = ddSound.playEffect('eat2', true);
                            role.eat('ice_cream');
                        })
                    ))
                }
                // 喝果汁
                else {
                    // zPauseTargetEvent(target, true);
                    // target.stopAllActions();
                    ddSound.playEffect('game_all_fly');
                    target.runAction(cc.sequence(
                        zGetBezierTo(0.5, target.getPosition(), target.pos_drink).easing(cc.easeIn(2)),
                        cc.callFunc(function () {
                            role.setAnimation(0, 'he', true);
                            role.setTimeScale(0.5);
                            target.juice.setTimeScale(0.25);
                            target.juice.setAnimation(0, target.aniName, false);
                            role.eat_drink_effectId = ddSound.playEffect('eat_drink');
                        })
                    ));
                    // zLogPos(target.getPosition());
                }
            }
        }, null);
        tray.addFood = (foodName) => {
            var food = new DP_DiningRoom_EatFood();
            food.isFood = true;
            tray.addChild(food);
            tray.food = food;
            if (foodName.indexOf('hot_dog') >= 0) {
                food.setName('hot_dog');
                food.setPosition(tray.width * 3 / 4, tray.height / 2);
                food.isHotDog(Global_DP_DiningRoom_MakeHotDog.sauce_type);
                init_Global_DP_DiningRoom_MakeHotDog();
            } else if (foodName.indexOf('hamburg') >= 0) {
                food.setName('hamburg');
                food.setPosition(tray.width * 3 / 4, tray.height * 3 / 5);
                food.isHamburg(Global_DP_DiningRoom_MakeHamburg.food_types);
                init_Global_DP_DiningRoom_MakeHamburg();
            } else if (foodName.indexOf('cake') >= 0) {
                food.setName('cake');
                food.setPosition(tray.width * 3 / 4, tray.height * 4.5 / 7);
                food.isCake(Global_DP_DiningRoom_MakeCake.types);
                init_Global_DP_DiningRoom_MakeCake();
            }
            zSetNodeEvent(listener, food);
        };
        tray.addDrink = (drinkName) => {
            var drink = new DP_DiningRoom_EatDrink();
            var world_pos_role = zGetWorldPosition(role);
            var role_pos_in_tray = zGetNodePosition(tray, world_pos_role);
            drink.isFood = false;
            tray.addChild(drink);
            tray.drink = drink;
            if (drinkName.indexOf('cola') >= 0) {
                var straw_type = Global_DP_DiningRoom_MakeCola.straw_type;
                var offset = null;
                if (straw_type == '0') {
                    offset = cc.p(-85, -100);
                } else if (straw_type == '1') {
                    offset = cc.p(-76, -100);
                } else if (straw_type == '2') {
                    offset = cc.p(-92, -117);
                }
                drink.setName('cola');
                drink.isCola(straw_type);
                drink.setPosition(tray.width * 5 / 17, tray.height * 5 / 7);
                drink.pos_back = drink.getPosition();
                // zLog('???');
                // zLogPos(role_pos_in_tray);
                // zLogPos(offset);
                drink.pos_drink = cc.pAdd(role_pos_in_tray, offset);
                init_Global_DP_DiningRoom_MakeCola();
            } else if (drinkName.indexOf('lemon') >= 0) {
                var straw_type = Global_DP_DiningRoom_MakeLemonJuice.straw_type;
                var offset = null;
                if (straw_type == 0) {
                    offset = cc.p(-65, -130);
                } else if (straw_type == 1) {
                    offset = cc.p(-54, -132);
                } else if (straw_type == 2) {
                    offset = cc.p(-79, -147);
                }
                drink.setName('lemon');
                // zLog('straw_type : ', straw_type);
                drink.isLemonJuice(straw_type);
                drink.setPosition(tray.width * 5 / 17, tray.height * 5 / 7);
                drink.pos_back = drink.getPosition();
                // drink.pos_drink = cc.pAdd(cc.p(256.17, 208.26), offset);
                drink.pos_drink = cc.pAdd(role_pos_in_tray, offset);
                init_Global_DP_DiningRoom_MakeLemonJuice();
            } else if (drinkName.indexOf('ice_cream') >= 0) {
                var types = Global_DP_DiningRoom_MakeIceCream.types;
                drink.setName('ice_cream');
                drink.isIceCream(types);
                drink.setPosition(tray.width * 7 / 17, tray.height * 13 / 16);
                init_Global_DP_DiningRoom_MakeIceCream();
            }
            zSetNodeEvent(listener.clone(), drink);
        };

        // zLog('food : ', foodName);
        // zLog('drink : ', drinkName);
        tray.addFood(foodName);
        tray.addDrink(drinkName);
        // tray.addFood('hot_dog');        // 'hot_dog' 'hamburg' 'cake'
        // tray.addDrink('ice_cream');         // 'cola' 'lemon' 'ice_cream'

        tray.into = function () {
            // zLog('into');
            zPauseTargetEvent(tray, true);
            tray.runAction(cc.sequence(
                cc.show(),
                cc.place(-cc.winSize.width / 2, tray.y),
                cc.moveTo(1, tray.end_pos).easing(cc.easeIn(2)),
                cc.callFunc(() => {
                    zResumeTargetEvent(tray, true);
                    var wp = zGetWorldPosition(Math.random() > 0.5 ? tray.food : tray.drink);
                    var np = self.convertToNodeSpace(wp);
                    tip_hand.autoTipAction(np);
                })
            ));
        };
        this.tray = tray;
    },
    onEnter: function () {
        this._super();
        this.tray.into();
    }
});