var Global_DP_DiningRoom_MakeCola = {
    dir: Global_DP_DiningRoom.dir + 'make_cola/',
    layer: null,
    machine: null,
    cup: null,
    cup_step: null,
    select_list: null,
    btn_ok: null,
    tray: null,
    straw_type: null,
    tip_hand: null,
    tip_arrow_curve: null
};

function init_Global_DP_DiningRoom_MakeCola() {
    Global_DP_DiningRoom_MakeCola.cup_step = null;
    Global_DP_DiningRoom_MakeCola.straw_type = null;
}

var DP_DiningRoom_MakeCola_Cup = cc.Node.extend({
    straw: null,
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeCola.cup = this;
        Global_DP_DiningRoom_MakeCola.cup_step = 'pour';

        var dir = Global_DP_DiningRoom_MakeCola.dir;
        var cup_front = zNewSpriteCreate(dir, 'cup_front', this);
        var cup_behind = zNewSpriteCreate(dir, 'cup_behind', this);
        cup_front.setLocalZOrder(2);
        cup_behind.setPosition(165.00, 399.04);

        var cola = zNewSpineAnimationCreate(Global_DP_DiningRoom.dir + 'spine/', 'skeleton', this);
        // cola.setAnimation(0, 'daokele', true);
        cola.setTimeScale(0.5);
        cola.setScale(1.8);
        cola.setPosition(165.00, 199.04);
        cola.setLocalZOrder(1);

        this.cola = cola;

        this.setContentSize(cup_front.getContentSize());
        cup_front.setPosition(cup_front.width / 2, cup_front.height / 2);
    },
    setCupEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeCola.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLogPos(target.getPosition());
            zPauseTargetEvent(target, true);
            var step = Global_DP_DiningRoom_MakeCola.cup_step;
            if (step == 'pour') {
                target.runAction(cc.sequence(
                    zGetBezierTo(0.5, target.getPosition(), cc.p(-91.87, 187.23)).easing(cc.easeIn(2)),
                    cc.callFunc(() => {
                        var machine = Global_DP_DiningRoom_MakeCola.machine;
                        machine.setHandleEvent();
                        ddSound.stopAll();
                        ddSound.playEffect('turn_on_the_handle');
                        var tip_arrow_curve = Global_DP_DiningRoom_MakeCola.tip_arrow_curve;
                        var layer = Global_DP_DiningRoom_MakeCola.layer;
                        var wp = zGetWorldPosition(machine.machine_handle);
                        var np = layer.convertToNodeSpace(wp);
                        tip_arrow_curve.autoTipAction(cc.pAdd(np, cc.p(0, 0)));
                    })
                ));
                Global_DP_DiningRoom_MakeCola.cup_step = 'put';
            } else if (step == 'put') {
                var tray = Global_DP_DiningRoom_MakeCola.tray;
                var tray_pos = tray.baseImage.getPosition();
                var node_pos = cc.p(tray.baseImage.width * (3 - 2.5) / 5, tray.baseImage.height * (1 - 1.5) / 3);
                var end_pos = cc.pAdd(tray_pos, node_pos);
                ddSound.playEffect('game_all_fly');
                target.runAction(cc.sequence(
                    zGetBezierTo(0.5, target.getPosition(), end_pos).easing(cc.easeOut(2)),
                    cc.callFunc(() => {
                        zChangeParent(target, tray.baseImage);
                        target.setPosition(tray.baseImage.width * 3 / 5, tray.baseImage.height / 3);
                    }),
                    cc.delayTime(0.5),
                    cc.callFunc(() => {
                        tray.out();
                    })
                ));
                var layer = Global_DP_DiningRoom_MakeCola.layer;
                layer.scheduleOnce(function () {
                    DP_DiningRoomMake();
                    layer.removeFromParent(true);
                }, 1.5);
            }
        }, null);
        zSetNodeEvent(listener, this);
        // zShowContentSize(this, this.getContentSize());
    },
    addStraw: function (name) {
        switch (name) {
            case 'straw_0':
                this.cola.setAnimation(0, 'kele' + 'fen', false);
                break;
            case 'straw_1':
                this.cola.setAnimation(0, 'kele' + 'lv', false);
                break;
            case 'straw_2':
                this.cola.setAnimation(0, 'kele' + 'huang', false);
                break;
        }
    }
});

var DP_DiningRoom_MakeCola_Machine = cc.Node.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeCola.machine = this;

        var dir = Global_DP_DiningRoom_MakeCola.dir;
        var machine_body = zNewSpriteCreate(dir, 'machine_body', this);
        var machine_handle = zNewSpriteCreate(dir, 'machine_handle', machine_body);
        var machine_input = zNewSpriteCreate(dir, 'machine_input', machine_body);

        machine_handle.setAnchorPoint(0, 0.5);
        machine_handle.setPosition(387.05, 465.30);
        machine_handle.setLocalZOrder(-1);
        machine_input.setPosition(189.24, 303.17);

        this.machine_handle = machine_handle;
        this.machine_input = machine_input;
    },
    setHandleEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
        }, function (touch, target) {
            var delta = touch.getDelta();
            if (delta.y < 0) {
                var tip_arrow_curve = Global_DP_DiningRoom_MakeCola.tip_arrow_curve;
                tip_arrow_curve.stopTipAction();
                zPauseTargetEvent(target, true);
                ddSound.playEffect('turn_handle');
                target.runAction(cc.sequence(
                    cc.rotateTo(0.2, 45),
                    cc.callFunc(() => {
                        var machine = Global_DP_DiningRoom_MakeCola.machine;
                        var cup = Global_DP_DiningRoom_MakeCola.cup;
                        var select_list = Global_DP_DiningRoom_MakeCola.select_list;
                        machine.machine_input.setGlobalZOrder(1);
                        ddSound.playEffect('game_dinning_pour_drink');
                        cup.cola.setAnimation(0, 'daokele', false);
                        cup.cola.setCompleteListener((trackEntry) => {
                            var name = trackEntry.animation ? trackEntry.animation.name : '';
                            if (name == 'daokele') {
                                machine.setVisible(false);
                                select_list.show();
                                select_list.into();
                                ddSound.stopAll();
                                ddSound.playEffect('select_choose_straw');
                            }
                        });
                    })
                ));

            }
        }, null, null);
        zSetNodeEvent(listener, this.machine_handle);
    }
});

var DP_DiningRoom_MakeColaLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeCola.layer = this;

        var machine = new DP_DiningRoom_MakeCola_Machine();
        machine.setPosition(0, 435.79);
        // machine.setColaFlowVisible(false);
        this.addChild(machine);
        this.machine_body = machine;

        var cup = new DP_DiningRoom_MakeCola_Cup();
        cup.setScale(0.5);
        cup.setPosition(195.04, 167.29);
        cup.setCupEvent();
        cup.setLocalZOrder(5);
        this.addChild(cup);

        // zAddTouchLogPosEvent(cup_front);
        // zAddTouchLogPosEvent(cup_behind);
        // zAddTouchLogPosEvent(cola_front);
        // zAddTouchLogPosEvent(cola_behind);
        // zAddTouchLogPosEvent(cola_flow);

        this.addSelectList();
        this.addButtonOk();
        this.addTray();
        this.addTip();
        this.addTipHand();
    },
    onEnter: function () {
        this._super();

        var tip_hand = Global_DP_DiningRoom_MakeCola.tip_hand;
        var cup = Global_DP_DiningRoom_MakeCola.cup;
        tip_hand.autoTipAction(cc.pAdd(cup.getPosition(), cc.p(100, 50)));
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeCola();
    },
    addSelectList: function () {
        // var dir_cola = Global_DP_DiningRoom_MakeCola.dir;
        var name_straw = ['purple', 'green', 'yellow'];
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            ddSound.playEffect('select_list_straw_' + name_straw[target.idx]);
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            // select_list.setItemBackPos(target.idx);
            var cup = Global_DP_DiningRoom_MakeCola.cup;
            var btn_ok = Global_DP_DiningRoom_MakeCola.btn_ok;
            var world_pos = cc.pAdd(zGetWorldPosition(cup), cc.p(cup.width / 2, cup.height / 2));
            var argus = {a: target.getName()};
            select_list.moveItemBezierTo(target.idx, world_pos, cup.addStraw, cup, argus, true);
            Global_DP_DiningRoom_MakeCola.straw_type = target.idx;
            btn_ok.into();
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 10},
            {from: cc.p(cc.winSize.width / 2 + 200, 451.40), to: cc.p(cc.winSize.width / 2 - 120, 451.40), time: 0.5},
            {name: 'side_column_box'},
            {dir: Global_DP_DiningRoom.dir_select_list, name: ['straw_0', 'straw_1', 'straw_2']},
            listener
        );

        Global_DP_DiningRoom_MakeCola.select_list = select_list;
    },
    addButtonOk: function () {
        var self = this;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeCola.select_list;
            var cup = Global_DP_DiningRoom_MakeCola.cup;
            var tray = Global_DP_DiningRoom_MakeCola.tray;
            select_list.out();
            btn_ok.out();
            self.scheduleOnce(function () {
                tray.into();
                cup.scheduleOnce(function () {
                    zResumeTargetEvent(cup, true);
                    zAddParticleDone(self);
                    ddSound.stopAll();
                    ddSound.playEffect('game_dinning_room_put_cola_on_tray');
                    var tip_hand = Global_DP_DiningRoom_MakeCola.tip_hand;
                    tip_hand.autoTipAction(cc.pAdd(cup.getPosition(), cc.p(100, 50)));
                }, 0.5);
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeCola.btn_ok = btn_ok;
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeCola.tray = zAddDiningRoomTray(this);

    },
    addTip: function () {
        this.addTipHand();
        this.addTipArrowCurve();
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeCola.tip_hand = tip_hand;
    },
    addTipArrowCurve: function () {
        var tip_arrow_curve = zAddTipArrowCurve(this);
        Global_DP_DiningRoom_MakeCola.tip_arrow_curve = tip_arrow_curve;
    }
});

