var Global_DP_DiningRoom_MakeHamburg = {
    dir: Global_DP_DiningRoom.dir + 'make_hamburg/',
    layer: null,
    select_list: null,
    btn_ok: null,
    hamburg: null,
    part: 0b0,
    step: null,
    tray: null,
    food_types: ['a', 'a', 'a'],
    tip_hand: null
};

function init_Global_DP_DiningRoom_MakeHamburg() {
    Global_DP_DiningRoom_MakeHamburg.part = 0b0;
    Global_DP_DiningRoom_MakeHamburg.step = null;
    Global_DP_DiningRoom_MakeHamburg.food_types = ['a', 'a', 'a'];
}

var DP_DiningRoomMakeHamburg_Hamburg = cc.Node.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeHamburg.hamburg = this;

        this.top = new cc.Sprite();
        this.bottom = new cc.Sprite();
        this.addChild(this.top, 4);
        this.addChild(this.bottom);
        this.food = [];
        for (var i = 0; i < 3; ++i) {
            this.food[i] = new cc.Sprite();
            this.addChild(this.food[i], 3 - i);
        }
    },
    setTopAndBottomImage: function (dir, topName, bottomName) {
        zSetSpriteTexture(dir, topName, this.top);
        zSetSpriteTexture(dir, bottomName, this.bottom);
        this.top.setPosition(-0.46, 235.65);
        this.bottom.setPosition(5.40, -131.69);
        // zAddTouchLogPosEvent(this.top);
        // zAddTouchLogPosEvent(this.bottom);
    },
    setFoodImage: function (foodIdx, dir, name) {
        // zLog(dir + name + suffixPNG);
        zSetSpriteTexture(dir, name, this.food[foodIdx]);
        this.food[foodIdx].setPosition(12.01, (1 - foodIdx) * 70 + 40);
        // zAddTouchLogPosEvent(this.food[foodIdx]);
    },
    addEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeHamburg.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            var hamburg = Global_DP_DiningRoom_MakeHamburg.hamburg;
            hamburg.x += delta.x;
            hamburg.y += delta.y;
        }, function (touch, target) {
            var hamburg = Global_DP_DiningRoom_MakeHamburg.hamburg;
            var tray = Global_DP_DiningRoom_MakeHamburg.tray;
            var endPos = cc.pAdd(tray.baseImage.getPosition(), cc.p(tray.baseImage.width / 4, 0));
            zPauseTargetEvent(hamburg, true);
            ddSound.playEffect('game_all_fly');
            hamburg.runAction(cc.sequence(
                // cc.spawn(cc.scaleTo(0.5, 0.4), cc.moveTo(0.5, endPos)),
                cc.spawn(cc.scaleTo(0.5, 0.4), zGetBezierTo(0.5, hamburg.getPosition(), endPos)).easing(cc.easeOut(2)),
                cc.callFunc(function () {
                    zChangeParent(hamburg, tray.baseImage);
                    hamburg.setPosition(tray.baseImage.width * 3 / 4, tray.baseImage.height / 2);
                })
            ));
            target.scheduleOnce(function () {
                tray.out();
                var layer = Global_DP_DiningRoom_MakeHamburg.layer;
                layer.scheduleOnce(function () {
                    DP_DiningRoomMake();
                    layer.removeFromParent(true);
                }, 1);
            }, 1);
            // zLogPos(hamburg.getPosition());
        }, null);
        zSetNodeEvent(listener.clone(), this.top);
        zSetNodeEvent(listener.clone(), this.bottom);
        zSetNodeEvent(listener.clone(), this.food[0]);
        zSetNodeEvent(listener.clone(), this.food[1]);
        zSetNodeEvent(listener.clone(), this.food[2]);
    },
    press: function () {
        var part = [this.top, this.bottom, this.food[0], this.food[1], this.food[2]];
        for (var i = 0; i < part.length; ++i) {
            var x = part[i].x;
            var y = part[i].y;
            part[i].runAction(cc.sequence(
                cc.moveTo(0.3, x, y * 0.7).easing(cc.easeIn(2)),
                cc.moveTo(0.2, x, y * 0.9).easing(cc.easeOut(2)),
                cc.moveTo(0.4, x, y * 0.5).easing(cc.easeIn(2)),
                cc.moveTo(0.2, x, y * 0.7).easing(cc.easeOut(2))
            ));
        }
        ddSound.playEffect('game_dinning_room_hamburg_press');
    }
});

var DP_DiningRoom_MakeHamburgLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeHamburg.layer = this;

        this.addSelectList();
        this.addHamburg();
        this.addButtonOk();
        this.addTray();
        this.addTipHand();
    },
    onEnter: function () {
        this._super();

        ddSound.stopAll();
        ddSound.playEffect('select_choose_side_dish');
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeHamburg();
    },
    addSelectList: function () {
        var dir_hamburg = Global_DP_DiningRoom_MakeHamburg.dir;
        var name_a = ['vegetable', 'cheese', 'meat_pie'];    // 青菜 芝士 肉饼
        var name_b = ['tomato', 'egg', 'fried_prawn'];    // 番茄 鸡蛋 炸虾
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            // zLog('item name : ', target.getName());
            // zLog('item localZOrder :', target.getLocalZOrder());
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            if (target.getName().indexOf('a') >= 0) {
                ddSound.playEffect('select_list_hamburg_a_' + name_a[target.idx]);
            } else if (target.getName().indexOf('b') >= 0) {
                ddSound.playEffect('select_list_hamburg_b_' + name_b[target.idx]);
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            var hamburg = Global_DP_DiningRoom_MakeHamburg.hamburg;
            var btn_ok = Global_DP_DiningRoom_MakeHamburg.btn_ok;
            var worldPos = zGetWorldPosition(hamburg);
            var argus = {a: target.idx, b: dir_hamburg, c: 'hamburg_' + target.getName()};
            select_list.moveItemBezierTo(target.idx, worldPos, hamburg.setFoodImage, hamburg, argus, true);
            target.scheduleOnce(function () {
                // a组 或 b组
                if (target.getName().indexOf('a') >= 0) {
                    zSetSpriteTexture(dir_hamburg, 'b_' + target.idx, target);
                    target.setName('b_' + target.idx);
                    Global_DP_DiningRoom_MakeHamburg.food_types[target.idx] = 'a';
                } else if (target.getName().indexOf('b') >= 0) {
                    zSetSpriteTexture(dir_hamburg, 'a_' + target.idx, target);
                    target.setName('a_' + target.idx);
                    Global_DP_DiningRoom_MakeHamburg.food_types[target.idx] = 'b';
                }
            }, 0.5);
            Global_DP_DiningRoom_MakeHamburg.part |= 1 << target.idx;
            if (Global_DP_DiningRoom_MakeHamburg.part == 7) {
                btn_ok.into();
            }
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 20},
            {from: cc.p(cc.winSize.width / 2 + 200, 451.40), to: cc.p(cc.winSize.width / 2 - 120, 451.40), time: 0.5},
            {name: 'side_column_box'},
            {dir: dir_hamburg, name: ['a_0', 'a_1', 'a_2']},
            listener
        );
        select_list.into();

        // select_list.hide();
        // select_list.pauseEvent();

        Global_DP_DiningRoom_MakeHamburg.select_list = select_list;
    },
    addHamburg: function () {
        var hamburg = new DP_DiningRoomMakeHamburg_Hamburg();
        hamburg.setTopAndBottomImage(Global_DP_DiningRoom_MakeHamburg.dir, 'hamburg_top', 'hamburg_bottom');
        hamburg.setPosition(0, 750 / 2);
        this.addChild(hamburg, 10);

        /*hamburg.setFoodImage(0, Global_DP_DiningRoom_MakeHamburg.dir, 'hamburg_a_0');
        hamburg.setFoodImage(1, Global_DP_DiningRoom_MakeHamburg.dir, 'hamburg_a_1');
        hamburg.setFoodImage(2, Global_DP_DiningRoom_MakeHamburg.dir, 'hamburg_a_2');
        hamburg.scheduleOnce(hamburg.press, 2);*/  // test
    },
    addButtonOk: function () {
        var self = this;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeHamburg.select_list;
            var hamburg = Global_DP_DiningRoom_MakeHamburg.hamburg;
            select_list.out();
            btn_ok.out();
            hamburg.press();
            self.scheduleOnce(function () {
                var tray = Global_DP_DiningRoom_MakeHamburg.tray;
                tray.into();
                hamburg.scheduleOnce(function () {
                    hamburg.addEvent();
                    zAddParticleDone(self);
                    ddSound.stopAll();
                    ddSound.playEffect('game_dinning_room_put_hamburg_on_tray');
                    var tip_hand = Global_DP_DiningRoom_MakeHamburg.tip_hand;
                    tip_hand.autoTipAction(hamburg.getPosition());
                }, 0.5)
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeHamburg.btn_ok = btn_ok;
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeHamburg.tray = zAddDiningRoomTray(this);
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeHamburg.tip_hand = tip_hand;
    }
});