var Global_DP_DiningRoom_MakeHotDog = {
    dir: Global_DP_DiningRoom.dir + 'make_hot_dog/',
    layer: null,
    select_list: null,
    btn_ok: null,
    hot_dog: null,
    part: 0b0,
    step: null,
    tray: null,
    sauce_type: 0,
    tip_hand: null
};

function init_Global_DP_DiningRoom_MakeHotDog() {
    Global_DP_DiningRoom_MakeHotDog.part = 0b0;
    Global_DP_DiningRoom_MakeHotDog.step = null;
    Global_DP_DiningRoom_MakeHotDog.sauce_type = 0;
}

var DP_DiningRoomMakeHotDog_HotDog = cc.Node.extend({
    ctor: function () {
        this._super();
        this.bread_behind = new cc.Sprite();
        this.bread_front = new cc.Sprite();
        this.addChild(this.bread_behind);
        this.addChild(this.bread_front, 4);
        this.food = [];
        for (var i = 0; i < 3; ++i) {
            this.food[i] = new cc.Sprite();
            this.addChild(this.food[i], i + 1);
        }

        // this.setFoodImage(0, Global_DP_DiningRoom_MakeHotDog.dir, 'hot_dog_part_0');
        // this.setFoodImage(1, Global_DP_DiningRoom_MakeHotDog.dir, 'hot_dog_part_1');
        // this.setFoodImage(2, Global_DP_DiningRoom_MakeHotDog.dir, 'hot_dog_part_2');
        // this.setBreadFrontImage(Global_DP_DiningRoom_MakeHotDog.dir, 'bread_front');

        this.sau_spine = zNewSpineAnimationCreate(Global_DP_DiningRoom.dir + 'spine/', 'skeleton', this);
        this.sau_spine.setLocalZOrder(10);
        this.sau_spine.setPosition(0, 50);
        // this.sau_spine.setAnimation(0, 'ji' + 'hong' + 'jiang', true);
    },
    setBreadBehindImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.bread_behind);
    },
    setBreadFrontImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.bread_front);
        // zAddTouchLogPosEvent(this.bread_front);
        this.bread_front.setPosition(0, -50);
    },
    setFoodImage: function (foodIdx, dir, name) {
        zSetSpriteTexture(dir, name, this.food[foodIdx]);
    },
    setSauceImage: function (name) {
        var clr = null;
        switch (name) {
            case 'sauce_0':
                clr = 'lv';
                break;
            case 'sauce_1':
                clr = 'huang';
                break;
            case 'sauce_2':
                clr = 'hong';
                break;
        }
        this.sau_spine.setAnimation(0, 'ji' + clr + 'jiang', false);
        ddSound.playEffect('game_dinning_hot_dog_pour_sauce');
    },
    addEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeHotDog.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            var hot_dog = Global_DP_DiningRoom_MakeHotDog.hot_dog;
            hot_dog.x += delta.x;
            hot_dog.y += delta.y;
        }, function (touch, target) {
            var tray = Global_DP_DiningRoom_MakeHotDog.tray;
            var hot_dog = Global_DP_DiningRoom_MakeHotDog.hot_dog;
            var endPos = cc.pAdd(tray.baseImage.getPosition(), cc.p(tray.baseImage.width / 4, 0));
            zPauseTargetEvent(hot_dog, true);
            ddSound.playEffect('game_all_fly');
            hot_dog.runAction(cc.sequence(
                // cc.spawn(cc.scaleTo(0.5, 0.5), cc.moveTo(0.5, endPos)),
                cc.spawn(cc.scaleTo(0.5, 0.5), zGetBezierTo(0.5, hot_dog.getPosition(), endPos)).easing(cc.easeOut(2)),
                cc.callFunc(function () {
                    zChangeParent(hot_dog, tray.baseImage);
                    hot_dog.setPosition(tray.baseImage.width * 3 / 4, tray.baseImage.height / 2);
                })
            ));
            target.scheduleOnce(function () {
                tray.out();
                var layer = Global_DP_DiningRoom_MakeHotDog.layer;
                layer.scheduleOnce(function () {
                    DP_DiningRoomMake();
                    layer.removeFromParent(true);
                }, 1);
            }, 1);
        }, null);
        zSetNodeEvent(listener.clone(), this.bread_behind);
        zSetNodeEvent(listener.clone(), this.bread_front);
    }
});

var DP_DiningRoom_MakeHotDogLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeHotDog.layer = this;

        this.addTray();
        this.addHotDog();
        this.addSelectList();
        this.addButtonOk();
        this.addTipHand();
    },
    onEnter: function () {
        this._super();

        ddSound.stopAll();
        ddSound.playEffect('select_choose_side_dish');
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeHotDog();
    },
    addButtonOk: function () {
        var self = this;
        var dir = Global_DP_DiningRoom_MakeHotDog.dir;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeHotDog.select_list;
            var hot_dog = Global_DP_DiningRoom_MakeHotDog.hot_dog;
            select_list.out();
            btn_ok.out();
            hot_dog.setBreadFrontImage(dir, 'bread_front');
            self.scheduleOnce(function () {
                if (Global_DP_DiningRoom_MakeHotDog.step == 'part') {
                    select_list.setItem(dir, 'sauce_0', 0);
                    select_list.setItem(dir, 'sauce_1', 1);
                    select_list.setItem(dir, 'sauce_2', 2);
                    select_list.into();
                } else if (Global_DP_DiningRoom_MakeHotDog.step == 'sauce') {
                    var tray = Global_DP_DiningRoom_MakeHotDog.tray;
                    tray.into();
                    hot_dog.scheduleOnce(function () {
                        var tip_hand = Global_DP_DiningRoom_MakeHotDog.tip_hand;
                        tip_hand.autoTipAction(hot_dog.getPosition());
                        hot_dog.addEvent();
                        zAddParticleDone(self);
                        ddSound.stopAll();
                        ddSound.playEffect('game_dinning_room_put_hot_dog_on_tray');


                    }, 0.5);
                }
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeHotDog.btn_ok = btn_ok;
    },
    addSelectList: function () {
        var self = this;
        var name_part = ['hamburg_a_vegetable', 'hot_dog_ham', 'hot_dog_onion'];
        var name_sauce = ['mustard', 'yolk', 'tomato'];
        var dir_hot_dog = Global_DP_DiningRoom_MakeHotDog.dir;
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            // zLog('item name : ', target.getName());
            // select_list.scaleShowOtherItem(target.idx);
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            if (target.getName().indexOf('part') >= 0) {
                ddSound.playEffect('select_list_' + name_part[target.idx]);
            } else if (target.getName().indexOf('sauce') >= 0) {
                ddSound.playEffect('select_list_hot_dog_sauce_' + name_sauce[target.idx]);
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            var hot_dog = Global_DP_DiningRoom_MakeHotDog.hot_dog;
            var btn_ok = Global_DP_DiningRoom_MakeHotDog.btn_ok;
            var worldPos = zGetWorldPosition(hot_dog);
            if (target.getName().indexOf('part_') >= 0) {
                var argus = {a: target.idx, b: dir_hot_dog, c: 'hot_dog_' + target.getName()};
                select_list.moveItemBezierTo(target.idx, worldPos, hot_dog.setFoodImage, hot_dog, argus, true);
                // hot_dog.setFoodImage(dir_hot_dog, 'hot_dog_' + target.getName(), target.idx);
                Global_DP_DiningRoom_MakeHotDog.part |= (1 << target.idx);
                hot_dog.unscheduleAllCallbacks();
                hot_dog.scheduleOnce(function () {
                    if (Global_DP_DiningRoom_MakeHotDog.part == 0b111) {
                        // select_list.out();
                        btn_ok.into();
                        Global_DP_DiningRoom_MakeHotDog.step = 'part';
                    }
                }, 0.5);

            } else if (target.getName().indexOf('sauce') >= 0) {
                // select_list.setItemBackPos(target.idx);
                // select_list.scaleHideItem(target.idx);
                // select_list.resumeOtherItemEvent(target.idx);
                // hot_dog.setSauceImage(target.getName());
                var argus = {a: target.getName()};
                select_list.moveItemBezierTo(target.idx, cc.pAdd(worldPos, cc.p(-170, 120)), hot_dog.setSauceImage, hot_dog, argus, true);
                btn_ok.into();
                Global_DP_DiningRoom_MakeHotDog.sauce_type = target.idx;
                Global_DP_DiningRoom_MakeHotDog.step = 'sauce';
            }
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 10},
            {from: cc.p(cc.winSize.width / 2 + 200, 451.40), to: cc.p(cc.winSize.width / 2 - 120, 451.40), time: 0.5},
            {name: 'side_column_box'},
            {dir: dir_hot_dog, name: ['part_0', 'part_1', 'part_2']},
            listener
        );
        select_list.into();
        // select_list.hide();
        // select_list.pauseEvent();

        Global_DP_DiningRoom_MakeHotDog.select_list = select_list;
    },
    addHotDog: function () {
        var hot_dog = new DP_DiningRoomMakeHotDog_HotDog();
        hot_dog.setBreadBehindImage(Global_DP_DiningRoom_MakeHotDog.dir, 'bread_behind');
        hot_dog.setPosition(0, 750 / 2);
        this.addChild(hot_dog);
        Global_DP_DiningRoom_MakeHotDog.hot_dog = hot_dog;
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeHotDog.tray = zAddDiningRoomTray(this);
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeHotDog.tip_hand = tip_hand;
    }
});

