var Global_DP_Popcorn = {
    dir: 'res/game/popcorn/',
    layer: null,
    machine: null,
    popcorn_box: null,
    btn_ok: null,
    select_list: null,
    step: null,
    corn_part: 0b0,
    taste_idx: 0,
    box_idx: 0,
    coin_box: null,
    role: null,
    tip_hand: null
};

var DP_PopcornMachine = cc.Node.extend({
    taste: null,
    popcorn: null,
    popcornPos: [cc.p(10.88, -47.57), cc.p(-83.73, -4.84), cc.p(96.49, -11.35), cc.p(17.32, 4.74)],
    ctor: function () {
        Global_DP_Popcorn.machine = this;
        this._super();
        this.setName('machine');
        this.popcorn = [];

        var dir = Global_DP_Popcorn.dir;
        var base = zNewSpriteCreate(dir, 'machine_base', this);
        var lid = zNewSpriteCreate(dir, 'machine_lid', this);
        base.setLocalZOrder(7);
        lid.setPosition(7.52, 352.80);
        lid.setLocalZOrder(10);
        this.addButton();
        this.addPot();
        this.addGlassWindow();
        // zAddTouchLogPosEvent(lid);

        // this.addCornBottleAndButter();
    },
    onEnter: function () {
        this._super();
        showAdBanner(true, 0.17, 0);
        zPauseTargetEvent(this.machine_btn);
    },
    onExit: function () {
        this._super();
        Global_DP_Popcorn.corn_part = 0b0;
        showAdBanner(true, 0.3, 0);
    },
    addButton: function () {
        // 爆米花机上的按钮 开始被暂停事件 放好玉米粒和黄油后恢复事件
        // 点击开始震动爆米花机 延时后右侧栏添加盛爆米花的盒子
        var machine_btn = zNewSpriteCreate(Global_DP_Popcorn.dir, 'machine_btn_normal', this);
        machine_btn.setPosition(0, -165.87);
        machine_btn.setLocalZOrder(10);
        var touchEnded = function (touch, target) {
            var machine = Global_DP_Popcorn.machine;
            var tip_hand = Global_DP_Popcorn.tip_hand;
            zPauseTargetEvent(target);
            zSetSpriteTexture(Global_DP_Popcorn.dir, 'machine_btn_normal', target);
            tip_hand.stopTipAction();
            machine.shakePot();
            ddSound.playEffect('game_popcorn_btn');
        };
        var listener = zNewEventListenerCreate(function (touch, target) {
            zSetSpriteTexture(Global_DP_Popcorn.dir, 'machine_btn_light', target);
        }, null, touchEnded, touchEnded);
        zSetNodeEvent(listener, machine_btn);
        this.machine_btn = machine_btn;
        // zAddTouchLogPosEvent(btn);
    },
    addPot: function () {
        var self = this;
        var dir = Global_DP_Popcorn.dir;
        // 爆米花锅 可以打开、关闭和震动

        var pot_spine = zNewSpineAnimationCreate(dir + 'spine/', 'skeleton', this);
        pot_spine.setPosition(24.86, 140.96);
        // pot_spine.setAnimation(0, 'guogaishang', false);
        // pot_spine.setAnimation(0, 'huangyou', true);
        // pot_spine.setTimeScale(0.1);
        // pot_spine.setContentSize(cc.size(200, 200));
        // zAddTouchLogPosEvent(pot_spine);

        this.openPotLid = function () {
            pot_spine.setAnimation(0, 'guogaishang', false);
        };
        this.closePotLid = function () {
            pot_spine.setAnimation(0, 'guogaixia', false);
        };
        this.shakePot = function () {
            pot_spine.setAnimation(0, 'guohuangdong', true);
            pot_spine.pot_shake_effectId = ddSound.playEffect('game_popcorn_pot_shake', true);
        };

        // var popcorn_name = '1';
        var shake_count = 0;
        var baozha_count = 0;
        pot_spine.setCompleteListener((trackEntry) => {
            var aniName = trackEntry.animation ? trackEntry.animation.name : '';
            var popcorn_name = Global_DP_Popcorn.taste_idx + 1;
            if (aniName == 'gougaishang') {

            } else if (aniName == 'guogaixia') {
                self.removeCornMaterials();
            } else if (aniName == 'guohuangdong') {
                var loop_count = trackEntry.loop;
                // zLog('loop : ', loop_count, ', time : ', trackEntry.animation.duration.toFixed(2));
                shake_count++;
                if (shake_count * trackEntry.animation.duration > 3) {
                    shake_count = 0;
                    ddSound.stopEffect(pot_spine.pot_shake_effectId);
                    pot_spine.pot_drop_popcorn_effectId = ddSound.playEffect('game_popcorn_pot_drop_popcorn', true);
                    pot_spine.setAnimation(0, 'baozha' + popcorn_name + 'kaishi', false);
                }
            } else if (aniName == 'baozha' + popcorn_name + 'kaishi') {
                pot_spine.setAnimation(0, 'baozha' + popcorn_name + 'xunhuan', true);
            } else if (aniName == 'baozha' + popcorn_name + 'xunhuan') {
                baozha_count++;
                if (baozha_count / 3 == 4) {
                    // zLog('baozha_count : ', baozha_count);
                    baozha_count = 0;
                    pot_spine.setAnimation(0, 'baozha' + popcorn_name + 'jieshu', false);
                    ddSound.stopEffect(pot_spine.pot_drop_popcorn_effectId);
                    self.addPopcorn('machine_popcorn_g' + Global_DP_Popcorn.taste_idx + '_3');
                } else if (baozha_count % 3 == 0) {
                    self.addPopcorn('machine_popcorn_g' + Global_DP_Popcorn.taste_idx + '_' + (baozha_count / 3 - 1));
                }
            } else if (aniName == 'baozha' + popcorn_name + 'jieshu') {
                var select_list = Global_DP_Popcorn.select_list;
                select_list.setItem(Global_DP_Popcorn.dir, 'box_0', 0);
                select_list.setItem(Global_DP_Popcorn.dir, 'box_1', 1);
                select_list.setItem(Global_DP_Popcorn.dir, 'box_2', 2);
                select_list.into();
                self.scheduleOnce(() => {
                    ddSound.stopAll();
                    ddSound.playEffect('select_choose_box');
                }, 1);
            }
        });

        this.openPotLid();
    },
    addPopcorn: function (name) {
        var popcorn = zNewSpriteCreate(Global_DP_Popcorn.dir, name, this);
        popcorn.setPosition(this.popcornPos[this.popcorn.length]);
        this.popcorn.push(popcorn);
        // zLog('add popcorn, now : ', this.popcorn.length, ' name : ', name);
        // zAddTouchLogPosEvent(popcorn);
    },
    addGlassWindow: function () {
        var self = this;
        // 玻璃窗 初始开着 玉米粒和黄油都加好后关闭
        var glass_window_mask = new cc.ClippingNode();
        glass_window_mask.setPosition(7.19, 128.92);
        glass_window_mask.setInverted(false);
        glass_window_mask.setAlphaThreshold(0);
        glass_window_mask.setStencil(new cc.Sprite(zGetFullPathPNG(Global_DP_Popcorn.dir, 'machine_glass_window')));
        var glass_window = zNewSpriteCreate(Global_DP_Popcorn.dir, 'machine_glass_window', glass_window_mask);
        glass_window.setPosition(0, glass_window.height);
        this.addChild(glass_window_mask, 5);
        this.closeGlassWindow = function () {
            glass_window.runAction(cc.moveTo(0.5, 0, 0));
            ddSound.playEffect('game_popcorn_glass_window');
        };
        this.openGlassWindow = function () {
            glass_window.runAction(cc.moveTo(0.5, 0, glass_window.height));
            ddSound.playEffect('game_popcorn_glass_window');
        }
        // zAddTouchLogPosEvent(glass_window);
    },
    addTaste: function (name) {
        // 选了口味之后 在锅里添加或替换口味
        if (this.taste) {
            this.removeChild(this.taste);
        }
        var taste = zNewSpriteCreate(Global_DP_Popcorn.dir, name, this);
        taste.setScale(0.8);
        taste.setPosition(25.16, 131.93);
        taste.setLocalZOrder(-3);
        this.taste = taste;
        // zAddTouchLogPosEvent(this.taste);
        // zLog('taste world pos : ');
        // zLogPos(this.convertToWorldSpace(cc.p(25.16, 131.93)));
    },
    addCornBottleAndButter: function () {
        var dir = Global_DP_Popcorn.dir;
        // 玉米粒瓶子或黄油碗事件
        var listener = zNewEventListenerCreate(function (touch, target) {
            zPauseTargetEvent(target.other);
            var tip_hand = Global_DP_Popcorn.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            target.runAction(cc.sequence(
                cc.moveTo(0.5, target.pos_end),
                cc.callFunc(() => {
                    target.spine.setAnimation(0, target.getName() + '1', false);
                    ddSound.playEffect(target.getName() == 'huangyou' ? 'game_all_fly' : 'game_popcorn_pour_popcorn_particle');
                    // zAddTouchLogPosEvent(target);
                })
            ));
            // zLogPos(target.getPosition());
            zPauseTargetEvent(target);
            target.spine.setCompleteListener((trackEntry) => {
                var aniName = trackEntry.animation ? trackEntry.animation.name : '';
                if (aniName == target.getName() + '1') {
                    Global_DP_Popcorn.corn_part |= (1 << target.idt);
                    target.setLocalZOrder(3);
                    // zLog('corn_part : ', Global_DP_Popcorn.corn_part.toString(2));
                    if (Global_DP_Popcorn.corn_part != 0b11) {
                        zResumeTargetEvent(target.other);
                    } else {
                        var machine = Global_DP_Popcorn.machine;
                        target.setLocalZOrder(-1);
                        target.other.setLocalZOrder(-2);
                        machine.closePotLid();
                        machine.closeGlassWindow();
                        machine.scheduleOnce(function () {
                            zResumeTargetEvent(machine.machine_btn);
                            ddSound.stopAll();
                            ddSound.playEffect('turn_on_the_switch');
                            var tip_hand = Global_DP_Popcorn.tip_hand;
                            var layer = Global_DP_Popcorn.layer;
                            var wp = zGetWorldPosition(machine.machine_btn);
                            var np = layer.convertToNodeSpace(wp);
                            tip_hand.autoTipAction(cc.pAdd(np, cc.p(50, -50)));
                        }, 1);
                    }
                }
            });
        }, null);
        var corn_materials = [];
        var name = ['huangyou', 'yumili'];
        var pos_material = [cc.p(312.53 + 50, 491.07 - 350), cc.p(540.98 + 50, 524.12 - 350)];
        var pos_end_material = [cc.p(95.39 + 50, 676.39 - 350 - 30 + 5), cc.p(94.25 + 50, 697.83 - 350 - 30 + 5)];
        var pos_spine = [cc.p(-17, -100), cc.p(-50, -90)];
        var size = [cc.size(209, 120), cc.size(140, 185)];
        for (var i = 0; i < name.length; ++i) {
            var corn_material = new cc.Node();
            var corn_material_spine = zNewSpineAnimationCreate(dir + 'spine/', 'skeleton', corn_material);
            corn_material.setPosition(pos_material[i]);
            corn_material.setContentSize(size[i]);
            corn_material.setAnchorPoint(0.5, 0.5);
            corn_material.setName(name[i]);
            corn_material.idt = i;
            corn_material.pos_end = pos_end_material[i];
            corn_material.spine = corn_material_spine;
            corn_materials.push(corn_material);
            corn_material_spine.setAnimation(0, name[i] + '2', false);
            corn_material_spine.setPosition(pos_spine[i]);
            this.addChild(corn_material, 15);
            zSetNodeEvent(listener.clone(), corn_material);
            // zAddTouchLogPosEvent(corn_material);
        }
        corn_materials[0].other = corn_materials[1];
        corn_materials[1].other = corn_materials[0];
        this.removeCornMaterials = function () {
            corn_materials[0].removeFromParent(true);
            corn_materials[1].removeFromParent(true);
            this.taste.removeFromParent(true);
        };
        var tip_hand = Global_DP_Popcorn.tip_hand;
        var layer = Global_DP_Popcorn.layer;
        var wp = zGetWorldPosition(corn_materials[Math.floor(Math.random() * 2)]);
        var np = layer.convertToNodeSpace(wp);
        tip_hand.autoTipAction(cc.pAdd(np, cc.p(25, -50)));
    },
    removePopcorn: function () {
        var popcorn = this.popcorn.pop();
        if (popcorn) {
            popcorn.removeFromParent(true);
            // zLog('machine remove popcorn');
            return true;
        }
        // zLog('remove popcorn, then : ', this.popcorn.length);
        return false;
    }
});

var DP_PopcornLayer = cc.Layer.extend({
    popcorn_box: null,
    ctor: function () {
        this._super();
        this.x = cc.winSize.width / 2;
        this.y = Global_DP.sinkY;
        Global_DP_Popcorn.layer = this;

        var bg_hd = zNewSpriteCreate(Global_DP_Popcorn.dir, 'bg_hd', this);
        bg_hd.setAnchorPoint(0.5, 0);

        this.addPopcornMachine();
        this.addButtonOk();
        this.addSelectList();
        // this.addPopcornBox();
        this.addPopcornShovel();
        this.addCoinBox();
        // this.addRole();
        this.addTipHand();

        zAddBackButtonBegin(this);

        // this.addCornBottleAndButter();

    },
    addPopcornMachine: function () {
        // 爆米花机
        var machine = new DP_PopcornMachine();
        machine.setPosition(-50, 750 / 2);
        this.addChild(machine);
    },
    addButtonOk: function () {
        // 各种需要确认时的按钮
        // 确认口味时 添加一瓶玉米粒和一碗黄油
        // 确认盛放爆米花盒子时 准备铲爆米花
        var self = this;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_Popcorn.select_list;
            select_list.out();
            btn_ok.out();
            self.scheduleOnce(function () {
                var layer = Global_DP_Popcorn.layer;
                var machine = Global_DP_Popcorn.machine;
                if (Global_DP_Popcorn.step == 'taste') {
                    machine.addCornBottleAndButter();
                    ddSound.stopAll();
                    ddSound.playEffect('game_popcorn_add_butter_and_particle');
                    // layer.addCornBottleAndButter();
                } else if (Global_DP_Popcorn.step == 'box') {
                    machine.openGlassWindow();
                    machine.scheduleOnce(function () {
                        // layer.addPopcornBox('box_' + Global_DP_Popcorn.box_idx);
                        layer.popcorn_shovel.into();
                        ddSound.stopAll();
                        ddSound.playEffect('game_popcorn_put_into_box');
                    }, 0.5);
                }
            }, 1);
        }, this);
        Global_DP_Popcorn.btn_ok = btn_ok;
    },
    addSelectList: function () {
        var name_taste = ['popcorn_taste_caramel', 'popcorn_taste_mango', 'chocolate'];
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            // zLog('item name : ', target.getName());
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            target.setLocalZOrder(10);
            ddSound.stopAll();
            if (target.getName().indexOf('taste') >= 0) {
                ddSound.playEffect('select_list_' + name_taste[target.idx]);
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            var machine = Global_DP_Popcorn.machine;
            var btn_ok = Global_DP_Popcorn.btn_ok;
            var layer = Global_DP_Popcorn.layer;
            var machineWorldPos = zGetWorldPosition(machine);
            if (target.getName().indexOf('taste') >= 0) {
                var argus = { a: target.getName() };
                var endWorldPos = cc.pAdd(machineWorldPos, cc.p(0, 130));
                select_list.moveItemBezierTo(target.idx, endWorldPos, machine.addTaste, machine, argus, true);
                btn_ok.into();
                Global_DP_Popcorn.taste_idx = target.idx;
                Global_DP_Popcorn.step = 'taste';
            } else if (target.getName().indexOf('box') >= 0) {
                var argus = { a: 'box_' + target.idx };
                select_list.moveItemBezierTo(target.idx, cc.p(950.51, 304.72), layer.addPopcornBox, layer, argus, true);
                btn_ok.into();
                Global_DP_Popcorn.box_idx = target.idx;
                Global_DP_Popcorn.step = 'box';
            }
            // zLogPos(target.getPosition());
        }, null);
        var select_list = zAddSelectList(this,
            { name: 'side_column', zOrder: 1 },
            {
                from: cc.p(cc.winSize.width / 2 + 200, 451.40),
                to: cc.p(542.16 + (isFullScreenDevice() ? 65 : 0), 451.40),
                time: 0.5
            },
            { name: 'side_column_box' },
            { dir: Global_DP_Popcorn.dir, name: ['taste_0', 'taste_1', 'taste_2'] },
            listener
        );
        select_list.into();
        this.scheduleOnce(() => {
            ddSound.stopAll();
            ddSound.playEffect('select_choose_taste_you_like');
        }, 1);


        Global_DP_Popcorn.select_list = select_list;
    },
    addPopcornBox: function (name) {
        // zLog(zGetFullPath(Global_DP_Popcorn.dir, name));
        if (this.popcorn_box) {
            this.removeChild(this.popcorn_box);
        }
        var popcorn_box = zNewSpriteCreate(Global_DP_Popcorn.dir, name, this);
        popcorn_box.setPosition(283.51, 384.72);
        // zLog('box world Pos : ');
        // zLogPos(this.convertToWorldSpace(cc.p(283.51, 384.72)));
        popcorn_box.setScale(0.8);
        popcorn_box.runAction(cc.scaleTo(0.5, 1));
        popcorn_box.popcorn_count = 0;
        // zAddTouchLogPosEvent(popcorn_box);
        popcorn_box.addPopcorn = function (name) {
            // zLog('popcorn_box add popcorn');
            popcorn_box.popcorn_count++;
            if (popcorn_box.popcorn_count == 4) {
                // zLog('popcorn_box real add popcorn');
                var popcorn = zNewSpriteCreate(Global_DP_Popcorn.dir, name, popcorn_box);
                popcorn.setLocalZOrder(-1);
                popcorn.setPosition(100, 200);

                var layer = Global_DP_Popcorn.layer;
                layer.scheduleOnce(layer.addRole, 1);
            }
        };
        popcorn_box.addEvent = function () {
            var role = Global_DP_Popcorn.role;
            var box_clr = ['lan', 'cheng', 'huang'];
            var listener = zNewEventListenerCreate((touch, target) => {
                target.setLocalZOrder(role.getLocalZOrder() + 1);
                target.stopTipAction();
            }, (touch, target) => {
                var delta = touch.getDelta();
                target.x += delta.x;
                target.y += delta.y;
            }, (touch, target) => {
                var p1 = target.getPosition();
                var p2 = cc.pAdd(role.getPosition(), cc.p(0, 130));
                target.runAction(cc.sequence(
                    cc.spawn(zGetBezierTo(0.5, p1, p2), cc.scaleTo(0.5, 0.5)),
                    cc.callFunc(() => {
                        var box_idx = Global_DP_Popcorn.box_idx;
                        var taste_idx = Global_DP_Popcorn.taste_idx;
                        // zLog(box_idx);
                        // zLog(taste_idx);
                        // zLog(box_clr[box_idx] + 'daizi' + (taste_idx + 1));
                        role.setAnimation(0, box_clr[box_idx] + 'daizi' + (taste_idx + 1), true);
                        role.eat_effectId = ddSound.playEffect('eat2', true);
                    }),
                    cc.removeSelf(true)
                ));
            }, null);
            zSetNodeEvent(listener, popcorn_box);
        };
        popcorn_box.tipAction = function () {
            popcorn_box.stopAllActions();
            popcorn_box.runAction(cc.sequence(
                cc.scaleTo(0.2, 1.1).easing(cc.easeIn(2)),
                cc.scaleTo(0.2, 0.9).easing(cc.easeOut(2)),
                cc.scaleTo(0.2, 1.1).easing(cc.easeIn(2)),
                cc.scaleTo(0.2, 0.9).easing(cc.easeOut(2)),
                cc.scaleTo(0.2, 1).easing(cc.easeOut(2))
            ));
        };
        popcorn_box.stopTipAction = function () {
            popcorn_box.unschedule(popcorn_box.tipAction);
            popcorn_box.stopAllActions();
            popcorn_box.setScale(1);
        };
        this.popcorn_box = popcorn_box;
        Global_DP_Popcorn.popcorn_box = popcorn_box;
    },
    addPopcornShovel: function () {
        var machine = Global_DP_Popcorn.machine;
        var dir = Global_DP_Popcorn.dir;
        var popcorn_shovel = zNewSpriteCreate(dir, 'shovel', this);
        popcorn_shovel.setLocalZOrder(15);
        popcorn_shovel.setAnchorPoint(193 / popcorn_shovel.width, 108 / popcorn_shovel.height);
        popcorn_shovel.into = function () {
            popcorn_shovel.setPosition(cc.winSize.width / 2 + 200, machine.y + 80);
            popcorn_shovel.runAction(cc.sequence(
                cc.moveTo(0.5, machine.x + 120, popcorn_shovel.y).easing(cc.easeIn(2))
            ));
        };
        popcorn_shovel.out = function () {
            popcorn_shovel.runAction(cc.sequence(
                cc.moveTo(0.5, cc.winSize.width / 2 + 200, popcorn_shovel.y).easing(cc.easeOut(2)),
                cc.removeSelf(true)
            ));
            var popcorn_box = Global_DP_Popcorn.popcorn_box;
            popcorn_box.schedule(popcorn_box.tipAction, 4, 655350, 2);
        };
        popcorn_shovel.addPopcorn = function (name) {
            if (!popcorn_shovel.popcorn) {
                // zLog('shovel add popcorn : ', name);
                var popcorn = zNewSpriteCreate(dir, name, popcorn_shovel);
                popcorn.setLocalZOrder(-1);
                popcorn.setPosition(55.13, 73.70);
                popcorn_shovel.popcorn = popcorn;
                // zAddTouchLogPosEvent(popcorn, true);
            } else {
                zSetNodeEvent(dir, name, popcorn_shovel.popcorn);
            }
        };
        popcorn_shovel.removePopcorn = function () {
            if (popcorn_shovel.popcorn) {
                // zLog('shovel remove popcorn');
                popcorn_shovel.popcorn.removeFromParent(true);
                popcorn_shovel.popcorn = null;
            }
        };
        popcorn_shovel.moveToPopcornBox = function () {
            var popcorn_box = Global_DP_Popcorn.popcorn_box;
            popcorn_shovel.runAction(cc.sequence(
                cc.moveTo(0.5, popcorn_box.x + 100, popcorn_box.y + 200),
                cc.callFunc(() => {
                    ddSound.playEffect('game_all_fly');
                }),
                cc.rotateTo(0.2, -30).easing(cc.easeIn(2)),
                cc.callFunc(() => {
                    popcorn_shovel.removePopcorn();
                    popcorn_box.addPopcorn('on_box_' + Global_DP_Popcorn.taste_idx);
                }),
                cc.rotateTo(0.2, 0).easing(cc.easeOut(2))
            ));
            return 0.5 + 0.2 + 0.2;
        };
        popcorn_shovel.backMachine = function () {
            popcorn_shovel.runAction(cc.sequence(
                cc.moveTo(0.5, machine.x + 120, machine.y + 80),
                cc.callFunc(() => {
                    zResumeTargetEvent(popcorn_shovel);
                })
            ))
        };
        var listener = zNewEventListenerCreate(function (touch, target) {
            var machine = Global_DP_Popcorn.machine;
            target.add_time = new Date();
            if (machine.removePopcorn()) {
                ddSound.playEffect('game_popcorn_shovel_popcorn');
                target.runAction(cc.sequence(
                    cc.rotateTo(0.2, -30).easing(cc.easeIn(2)),
                    cc.callFunc(() => {
                        target.addPopcorn('on_shovel_' + Global_DP_Popcorn.taste_idx);
                    }),
                    cc.rotateTo(0.2, 0).easing(cc.easeOut(2))
                ));
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            zPauseTargetEvent(target);
            var delta_time = (new Date() - target.add_time) / 1000;
            // zLog('delta_time 1 : ', delta_time);
            var machine = Global_DP_Popcorn.machine;
            // 时间够铲爆米花的动作完成了
            if (delta_time >= 0.45) {
                if (target.popcorn) {
                    var time = target.moveToPopcornBox();
                    target.scheduleOnce(() => {
                        // zLog('isArray : ', Array.isArray(machine.popcorn));
                        if (machine.popcorn[0]) {
                            popcorn_shovel.backMachine();
                        } else {
                            popcorn_shovel.out();
                        }
                    }, time);
                }
            }
            // 时间不够铲爆米花，延迟到铲完
            else {
                target.scheduleOnce(() => {
                    if (target.popcorn) {
                        var time = target.moveToPopcornBox();
                        target.scheduleOnce(() => {
                            // zLog('isArray : ', Array.isArray(machine.popcorn));
                            if (machine.popcorn[0]) {
                                popcorn_shovel.backMachine();
                            } else {
                                popcorn_shovel.out();
                            }
                        }, time);
                    }
                }, 0.45 - delta_time);
            }
        }, null);
        zSetNodeEvent(listener, popcorn_shovel);
        this.popcorn_shovel = popcorn_shovel;
    },
    addCoinBox: function () {
        Global_DP_Popcorn.coin_box = zAddCoinBox(this);
    },
    addRole: function () {
        var self = this;
        var role = zNewSpineAnimationCreate(Global_DP_Popcorn.dir + 'spine_eat/', 'chidongxi', this);
        // role.setAnimation(0, 'chengdaizi3', true);
        role.setScale(0.9);
        role.setLocalZOrder(20);
        role.runAction(cc.sequence(
            cc.place(500, 0),
            cc.bezierTo(0.5, [cc.p(500, 0), cc.p(250, 600), cc.p(0, 0)]),
            cc.callFunc(() => {
                loop_count = 0;
                role.setAnimation(0, 'huxi', true);
                // self.addPopcornBox('box_0');
                var popcorn_box = Global_DP_Popcorn.popcorn_box;
                popcorn_box.addEvent();
                zAddParticleDone(self);
                // role.setAnimation(0, 'chengdaizi' + (Global_DP_Popcorn.box_idx + 1), true);
                role.setCompleteListener((trackEntry) => {
                    var aniName = trackEntry.animation ? trackEntry.animation.name : '';
                    if (aniName.indexOf('daizi') >= 0) {
                        loop_count++;
                        if (loop_count == 6) {
                            role.setAnimation(0, 'kaixin', false);
                            ddSound.stopAll();
                            ddSound.playEffect('eat_food_good');
                        }
                    } else if (aniName == 'kaixin') {
                        umengEvent('GAME_SRC_DONE', 'popcorn');
                        cc.director.popScene();
                    }
                });
            })
        ));
        Global_DP_Popcorn.role = role;
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_Popcorn.tip_hand = tip_hand;
    }
});

var DP_PopcornScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_PopcornLayer();
        this.addChild(layer);

        zAddKeyboardBackEventCreate(this);
    }
});